//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  PaleVioletRed
#property  indicator_color2  LimeGreen
#property  indicator_width1  2
#property  indicator_width2  2
#property  indicator_minimum 0
#property  indicator_maximum 1

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    RPeriod         = 5;
extern bool   UsePercent      = true;
extern int    SSPeriod        = 5;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = true;
extern bool   alertsEmail     = false;
extern string soundFile       = "alert2.wav";

//
//
//
//
//

double RateOfChange[];
double trend[];
double valUp[];
double valDn[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init(){
//---- drawing settings
   IndicatorBuffers(4);
   SetIndexBuffer(0, valDn); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, valUp); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, RateOfChange);
   SetIndexBuffer(3, trend);
   
   
   //
   //
   //
   //
   //
       
   indicatorFileName   = WindowExpertName();
   returnBars          = TimeFrame=="returnBars";          if (returnBars)     return(0);
   calculateValue      = TimeFrame=="calculateValue";      if (calculateValue) return(0);
   timeFrame           = stringToTimeFrame(TimeFrame);
          
   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(timeFrame)+ " ROC2 Smoothed MTF(" + RPeriod + ")");
return(0);
}
  
//+------------------------------------------------------------------+
//| ROC calculation                          |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { valDn[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
   
     for (i=limit; i>=0; i--)
     {
         double ROC = iSsm(Close[i]-Close[i+RPeriod],SSPeriod,i,0);
         
         //
         //
         //
         //
         //
         
         if (UsePercent)
         {
           if (Close[i+RPeriod] != 0)
                RateOfChange[i] = 100 * ROC/Close[i+RPeriod];
         } else RateOfChange[i] = ROC;
         
         //
         //
         //
         //
         //
         
         valUp[i] = EMPTY_VALUE;
         valDn[i] = EMPTY_VALUE;
         trend[i] = trend[i+1];
            if (RateOfChange[i] > 0) trend[i] =  1;
            if (RateOfChange[i] < 0) trend[i] = -1;
            if (trend[i] ==  1)      valUp[i] = 1;
            if (trend[i] == -1)      valDn[i] = 1;
      } 
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;
        if (trend[whichBar] != trend[whichBar+1])
        if (trend[whichBar] == 1)
              doAlert("crossing zero up");
        else  doAlert("crossing zero down");       
      }          
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--){
      int y = iBarShift(NULL,timeFrame,Time[i]);               
         trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RPeriod,UsePercent,SSPeriod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,3,y);
         valUp[i] = EMPTY_VALUE;
         valDn[i] = EMPTY_VALUE;
            if (trend[i] ==  1) valUp[i] = 1;
            if (trend[i] == -1) valDn[i] = 1;
   }
   return(0);
}

//
//
//
//
//

double workSsm[][2];
#define _price  0
#define _ssm    1

double workSsmCoeffs[][4];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define Pi 3.14159265358979323846264338327950288

//
//
//
//
//

double iSsm(double price, double period, int i, int instanceNo)
{
   if (ArrayRange(workSsm,0) !=Bars)                 ArrayResize(workSsm,Bars);
   if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
   if (workSsmCoeffs[instanceNo][_period] != period)
   {
      workSsmCoeffs[instanceNo][_period] = period;
      double a1 = MathExp(-1.414*Pi/period);
      double b1 = 2.0*a1*MathCos(1.414*Pi/period);
         workSsmCoeffs[instanceNo][_c2] = b1;
         workSsmCoeffs[instanceNo][_c3] = -a1*a1;
         workSsmCoeffs[instanceNo][_c1] = 1.0 - workSsmCoeffs[instanceNo][_c2] - workSsmCoeffs[instanceNo][_c3];
   }

   //
   //
   //
   //
   //

      i = Bars-i-1;
      int s = instanceNo*2;   
          workSsm[i][s+_price] = price;
          workSsm[i][s+_ssm]   = workSsmCoeffs[instanceNo][_c1]*(workSsm[i][s+_price]+workSsm[i-1][s+_price])/2.0 + 
                                 workSsmCoeffs[instanceNo][_c2]*workSsm[i-1][s+_ssm]                              + 
                                 workSsmCoeffs[instanceNo][_c3]*workSsm[i-2][s+_ssm];
   return(workSsm[i][s+_ssm]);
} 

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10""M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

         message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ROC2 Super Smoother Histo ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," ROC2 Super Smoother Histo "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}
